2022-11-15 18:03:48 +00:00
|
|
|
import cadquery2 as cq
|
|
|
|
from cadquery2 import exporters
|
|
|
|
|
|
|
|
# Base for the notebook. Basically a kbd base that extends back
|
|
|
|
# as much as possible
|
|
|
|
|
|
|
|
# Thickness of the outer material
|
|
|
|
shell_t = 3
|
|
|
|
|
2022-11-22 18:41:47 +00:00
|
|
|
# Size of the kbd board
|
2023-01-26 14:08:58 +00:00
|
|
|
kbd_height = 95.5
|
|
|
|
kbd_width = 305
|
2022-11-22 18:41:47 +00:00
|
|
|
kbd_angle = 5
|
|
|
|
|
|
|
|
# Size of the whole object
|
|
|
|
width = kbd_width + 2 * shell_t
|
|
|
|
height = 164 # Max bed size
|
|
|
|
thickness = 20 + shell_t # 20 inside
|
|
|
|
|
2022-11-15 18:03:48 +00:00
|
|
|
# Insert Positions
|
|
|
|
ti_radius = 2.35
|
|
|
|
ti_depth = 6.25
|
|
|
|
|
2022-11-28 18:09:49 +00:00
|
|
|
# Positions are determined by measuring the keyboard
|
2023-01-27 14:23:04 +00:00
|
|
|
|
|
|
|
kbd_pillar_positions = [
|
|
|
|
(18.25, -16),
|
|
|
|
(142.5, -25.5),
|
|
|
|
(kbd_width - 20, -16),
|
|
|
|
(23.5, -79.5),
|
|
|
|
(145.5, -82.5),
|
|
|
|
(kbd_width - 19, -79.5),
|
|
|
|
]
|
|
|
|
|
|
|
|
|
2022-11-28 18:09:49 +00:00
|
|
|
# mounting holes
|
|
|
|
kbd_pillars = (
|
2022-11-15 18:03:48 +00:00
|
|
|
cq.Sketch()
|
2023-01-27 14:23:04 +00:00
|
|
|
.push(kbd_pillar_positions)
|
2023-01-26 18:11:16 +00:00
|
|
|
.circle(2.2, mode="a")
|
|
|
|
# Holes for self-tapping screws
|
2023-01-27 14:16:40 +00:00
|
|
|
.circle(1.1, mode="s")
|
2022-11-15 18:03:48 +00:00
|
|
|
)
|
|
|
|
|
2023-01-27 14:23:04 +00:00
|
|
|
kbd_lower_pillars = (
|
|
|
|
cq.Sketch()
|
|
|
|
.push(kbd_pillar_positions)
|
|
|
|
.circle(4, mode="a")
|
|
|
|
# Holes for self-tapping screws
|
|
|
|
.circle(1.1, mode="s")
|
|
|
|
)
|
|
|
|
|
2022-11-28 18:09:49 +00:00
|
|
|
# These are placed where convenient, and are used to join the top and bottom
|
|
|
|
# parts of the case.
|
|
|
|
# Measured from top-left corner OUTSIDE
|
|
|
|
mounting_pillar_positions = [
|
|
|
|
(6, -6),
|
|
|
|
(120, -6),
|
|
|
|
(170, -6),
|
2022-12-02 13:04:23 +00:00
|
|
|
(width - 6, -6),
|
|
|
|
(width - 6, -40),
|
2022-11-28 18:09:49 +00:00
|
|
|
]
|
|
|
|
|
|
|
|
mounting_pillars = (
|
|
|
|
cq.Sketch()
|
|
|
|
.push(mounting_pillar_positions)
|
|
|
|
.trapezoid(12, 12, 90, mode="a")
|
2022-11-29 12:27:15 +00:00
|
|
|
.circle(1.8, mode="s")
|
2022-11-28 18:09:49 +00:00
|
|
|
)
|
|
|
|
|
|
|
|
screw_holes = cq.Sketch().push(mounting_pillar_positions).circle(3, mode="a")
|
|
|
|
|
2023-01-26 14:08:58 +00:00
|
|
|
# battery_holder = (
|
|
|
|
# cq.Sketch()
|
|
|
|
# .polygon(
|
|
|
|
# [(-67, 5), (0, 5), (0, -12), (-67, -12), (-67, 5)],
|
|
|
|
# mode="a",
|
|
|
|
# )
|
|
|
|
# .trapezoid(83, 83, 90, mode="a")
|
|
|
|
# .trapezoid(80, 80, 90, mode="s")
|
|
|
|
# .polygon(
|
|
|
|
# [(-67, 3), (0, 3), (0, -10), (-67, -10), (-67, 3)],
|
|
|
|
# mode="s",
|
|
|
|
# )
|
|
|
|
# # Cutout for the
|
|
|
|
# .polygon(
|
|
|
|
# [(-67, 30), (0, 30), (0, 12), (-67, 12), (-67, 30)],
|
|
|
|
# mode="s",
|
|
|
|
# )
|
|
|
|
# )
|
2022-11-22 18:41:47 +00:00
|
|
|
|
2022-11-24 12:51:40 +00:00
|
|
|
|
2022-11-22 18:41:47 +00:00
|
|
|
power_in = cq.Sketch().circle(5, mode="a")
|
2022-11-23 13:25:10 +00:00
|
|
|
usb_in = cq.Sketch().trapezoid(13, 5.5, 90, mode="a")
|
2022-12-01 15:29:33 +00:00
|
|
|
switch_in = cq.Sketch().trapezoid(13.5, 8.5, 90, mode="a")
|
2022-11-22 18:41:47 +00:00
|
|
|
|
2022-11-15 18:03:48 +00:00
|
|
|
|
2022-11-28 18:09:49 +00:00
|
|
|
# Motherboard mount
|
|
|
|
|
|
|
|
|
2022-11-15 18:24:45 +00:00
|
|
|
def model():
|
|
|
|
return (
|
|
|
|
cq.Workplane("XY")
|
|
|
|
.workplane(offset=thickness / 2)
|
|
|
|
.tag("mid_height")
|
|
|
|
# Hollow box
|
|
|
|
.box(width, height, thickness)
|
|
|
|
.edges("|Z")
|
|
|
|
.fillet(2)
|
|
|
|
.faces(">Z")
|
|
|
|
.shell(-shell_t)
|
2022-11-22 18:41:47 +00:00
|
|
|
# Battery holder
|
2023-01-26 14:08:58 +00:00
|
|
|
# .workplaneFromTagged("mid_height")
|
|
|
|
# .center(-width / 2 + shell_t + 65, height / 2 - shell_t - 45)
|
|
|
|
# .placeSketch(battery_holder)
|
|
|
|
# .extrude(-height / 2)
|
2022-11-22 18:41:47 +00:00
|
|
|
# Power cable inlet
|
|
|
|
.faces("<X")
|
|
|
|
.workplane(centerOption="CenterOfBoundBox")
|
|
|
|
.center(-height / 2 + shell_t + 48.5, -3)
|
|
|
|
.placeSketch(power_in)
|
|
|
|
.cutBlind(-shell_t)
|
2022-11-23 13:25:10 +00:00
|
|
|
# USB inlet
|
|
|
|
.faces(">X")
|
|
|
|
.workplane(centerOption="CenterOfBoundBox")
|
|
|
|
.center(-height / 2 + shell_t + 50, -5)
|
|
|
|
.placeSketch(usb_in)
|
|
|
|
.cutBlind(-shell_t)
|
2022-11-24 13:30:05 +00:00
|
|
|
# Hole for power switch
|
|
|
|
.faces(">Y")
|
|
|
|
.workplane(centerOption="CenterOfBoundBox")
|
2022-11-28 18:09:49 +00:00
|
|
|
.center(0, 0)
|
2022-11-24 13:30:05 +00:00
|
|
|
.placeSketch(switch_in)
|
|
|
|
.cutBlind(-shell_t)
|
2022-11-15 18:24:45 +00:00
|
|
|
# Slanted mounting pillars on the kbd top
|
|
|
|
.faces(">Z")
|
|
|
|
.workplane(centerOption="CenterOfBoundBox")
|
2022-11-22 18:41:47 +00:00
|
|
|
# Top-left kbd corner inside the box
|
|
|
|
.center(-width / 2 + shell_t, kbd_height - height / 2 + shell_t)
|
2022-11-15 18:24:45 +00:00
|
|
|
.transformed(rotate=cq.Vector(kbd_angle, 0, 0))
|
|
|
|
.tag("sloped")
|
2023-01-27 16:16:09 +00:00
|
|
|
.workplane(offset=-1.5)
|
2022-11-28 18:09:49 +00:00
|
|
|
.placeSketch(kbd_pillars)
|
2022-11-15 18:24:45 +00:00
|
|
|
.extrude(-1000)
|
2023-01-27 14:23:04 +00:00
|
|
|
.workplaneFromTagged("sloped")
|
2023-01-27 16:16:09 +00:00
|
|
|
.workplane(offset=-4.5)
|
2023-01-27 14:23:04 +00:00
|
|
|
.placeSketch(kbd_lower_pillars)
|
|
|
|
.extrude(-1000)
|
2022-11-15 18:24:45 +00:00
|
|
|
# Remove the excess extrusion
|
|
|
|
.workplaneFromTagged("mid_height")
|
|
|
|
.transformed(offset=cq.Vector(0, 0, -thickness / 2))
|
|
|
|
.split(keepTop=True)
|
|
|
|
# Slope for the beyboard
|
|
|
|
.workplaneFromTagged("sloped")
|
|
|
|
.split(keepBottom=True)
|
2022-11-28 18:09:49 +00:00
|
|
|
# Pillars to join with top half
|
|
|
|
.workplaneFromTagged("mid_height")
|
|
|
|
.workplane(offset=-thickness / 2, centerOption="CenterOfBoundBox")
|
|
|
|
.center(-width / 2, height / 2)
|
|
|
|
.placeSketch(mounting_pillars)
|
|
|
|
.extrude(thickness)
|
|
|
|
# Holes to insert screws from the bottom
|
|
|
|
.workplaneFromTagged("mid_height")
|
|
|
|
.workplane(offset=-thickness / 2, centerOption="CenterOfBoundBox")
|
|
|
|
.center(-width / 2, height / 2)
|
|
|
|
.placeSketch(screw_holes)
|
|
|
|
# 13 is 20-7 (screw thread length - threaded insert depth)
|
|
|
|
.cutBlind(thickness - 13)
|
2022-11-15 18:24:45 +00:00
|
|
|
)
|
|
|
|
|
2022-11-15 19:01:20 +00:00
|
|
|
|
2022-11-28 18:09:49 +00:00
|
|
|
if __name__ == "__main__":
|
2022-11-15 18:24:45 +00:00
|
|
|
|
2022-11-28 18:09:49 +00:00
|
|
|
left_cutout = cq.Sketch().polygon(
|
2023-01-26 18:11:16 +00:00
|
|
|
[(0, 0), (width / 2, 0), (width / 2, -height), (0, -height), (0, 0)],
|
2022-11-28 18:09:49 +00:00
|
|
|
mode="a",
|
|
|
|
)
|
2022-11-15 18:24:45 +00:00
|
|
|
|
2022-11-28 18:09:49 +00:00
|
|
|
right_side = (
|
|
|
|
model()
|
|
|
|
.faces("<Z")
|
|
|
|
.workplaneFromTagged("mid_height")
|
|
|
|
.transformed(offset=cq.Vector(0, 0, -thickness / 2))
|
|
|
|
.center(-width / 2, height / 2)
|
|
|
|
.placeSketch(left_cutout)
|
|
|
|
.cutBlind(100)
|
|
|
|
)
|
2022-11-15 18:24:45 +00:00
|
|
|
|
2022-11-28 18:09:49 +00:00
|
|
|
exporters.export(right_side, "right_side.stl")
|
|
|
|
|
|
|
|
right_cutout = cq.Sketch().polygon(
|
|
|
|
[
|
2023-01-26 18:11:16 +00:00
|
|
|
(width / 2, 0),
|
2022-11-28 18:09:49 +00:00
|
|
|
(width, 0),
|
|
|
|
(width, -height),
|
2023-01-26 18:11:16 +00:00
|
|
|
(width / 2, -height),
|
|
|
|
(width / 2, 0),
|
2022-11-28 18:09:49 +00:00
|
|
|
],
|
|
|
|
mode="a",
|
|
|
|
)
|
|
|
|
|
|
|
|
left_side = (
|
|
|
|
model()
|
|
|
|
.faces("<Z")
|
|
|
|
.workplaneFromTagged("mid_height")
|
|
|
|
.transformed(offset=cq.Vector(0, 0, -thickness / 2))
|
|
|
|
.center(-width / 2, height / 2)
|
|
|
|
.placeSketch(right_cutout)
|
|
|
|
.cutBlind(100)
|
|
|
|
)
|
|
|
|
exporters.export(left_side, "left_side.stl")
|
2022-11-15 18:03:48 +00:00
|
|
|
|
2022-11-28 18:09:49 +00:00
|
|
|
exporters.export(model(), "model.stl")
|